--[[=============================================================================
    Copyright 2015 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.device_specific_commands = "2015.03.31"
end

--[[=============================================================================
    ExecuteCommand Code

    Define any functions for device specific commands (EX_CMD.<command>)
    received from ExecuteCommand that need to be handled by the driver.
===============================================================================]]
--function EX_CMD.NEW_COMMAND(tParams)
--	LogTrace("EX_CMD.NEW_COMMAND")
--	LogTrace(tParams)
--end

--[[
	Device Command: ZonePower
	Parameters:
		Power: Power state: values are "ON" and "OFF"
		Zone: zone id (1 based, must be corrected for zero based connection ids)
--]]
--[[
function EX_CMD.ZonePower(tParams)
	LogTrace("EX_CMD.ZonePower()")
	LogTrace(tParams)
	if(tParams["Power"] == "ON") then
		local output = tonumber(tParams["Zone"]) - 1
		--we should clear gPowerState for this zone since it may be out of sync, 
		--(i.e. the user may be firing this command to correct a problem where the the unit is off when it should be on)
		gReceiverProxy._PowerState[output] =  ""		
		PRX_CMD.CONNECT_OUTPUT(RECEIVER_PROXY_BINDINGID, {OUTPUT = output})
	else
		local output = tonumber(tParams["Zone"]) - 1	
		PRX_CMD.DISCONNECT_OUTPUT(RECEIVER_PROXY_BINDINGID, {OUTPUT = output})
	end
end
--]]