--[[=============================================================================
    Receiver Protocol Initialization Functions

    Copyright 2015 Control4 Corporation. All Rights Reserved.
===============================================================================]]

-- This macro is utilized to identify the version string of the driver template version used.
if (TEMPLATE_VERSION ~= nil) then
	TEMPLATE_VERSION.device_messages = "2015.03.31"
end


PROTOCOL_DECLARATIONS = {}

function ON_DRIVER_EARLY_INIT.receiver_init()

end

function ON_DRIVER_INIT.receiver_init()
	--LogTrace("ON_DRIVER_INIT.ProtocolDeclarations()")
	for k,v in pairs(PROTOCOL_DECLARATIONS) do
		if (PROTOCOL_DECLARATIONS[k] ~= nil and type(PROTOCOL_DECLARATIONS[k]) == "function") then
			PROTOCOL_DECLARATIONS[k]()
		end
	end	
end

function ON_DRIVER_LATEINIT.receiver_init()
end

--[[
function PROTOCOL_DECLARATIONS.CommandsTableInit_IR()
	LogTrace("PROTOCOL_DECLARATIONS.CommandsTableInit_IR()")

	CMDS_IR = {
		--index:  Proxy Command Name
		--value:  IR Code ID	 
		["ON"]             = "",
		["OFF"]            = "",
		["MUTE_ON"]        = "",
		["MUTE_OFF"]       = "",
		["MUTE_TOGGLE"]    = "",
		["INPUT_TOGGLE"]   = "",
		["NUMBER_0"]       = "", 	
		["NUMBER_1"]       = "",		
		["NUMBER_2"]       = "",	
		["NUMBER_3"]       = "",	
		["NUMBER_4"]       = "",	
		["NUMBER_5"]       = "",	
		["NUMBER_6"]       = "",	
		["NUMBER_7"]       = "",	
		["NUMBER_8"]       = "",	
		["NUMBER_9"]       = "",
		["STAR"]           = "",
		["DOT"]            = "",
		["INFO"]           = "", --Display
		["RECALL"]         = "",
		["PULSE_VOL_DOWN"] = "",
		["PULSE_VOL_UP"]   = "",
		["MENU"]           = "",
		["ENTER"]          = "",
		["UP"]             = "",
		["DOWN"]           = "",
		["LEFT"]           = "",
		["RIGHT"]          = "",
		["PREV"]           = "",
		["CANCEL"]         = "",
	}		
	
	--IR ZONE Commands
	CMDS_IR_ZONES = {}
	
	CMDS_IR_ZONES[0] = {
		--index:  Proxy Command Name
		--value:  IR Code ID
		["CONNECT_OUTPUT"] = "",
		["DISCONNECT_OUTPUT"] = "",	
		["VOLUME_UP"] = "",
		["VOLUME_DOWN"] = "",
		["MUTE_ON"] = "",
		["MUTE_OFF"] = "",
		["MUTE_TOGGLE"] = "",
	}	
	
	CMDS_IR_ZONES[1] = {
		["CONNECT_OUTPUT"] = "",
		["DISCONNECT_OUTPUT"] = "",
		["VOLUME_UP"] = "",
		["VOLUME_DOWN"] = "",
		["MUTE_ON"] = "",
		["MUTE_OFF"] = "",
		["MUTE_TOGGLE"] = "",
	}		
	
	CMDS_IR_ZONES[2] = {
		["CONNECT_OUTPUT"] = "",
		["DISCONNECT_OUTPUT"] = "",	
		["VOLUME_UP"] = "",
		["VOLUME_DOWN"] = "",
		["MUTE_ON"] = "",
		["MUTE_OFF"] = "",
		["MUTE_TOGGLE"] = "",		
	}	
	
	CMDS_IR_ZONES[3] = {
		["CONNECT_OUTPUT"] = "",
		["DISCONNECT_OUTPUT"] = "",	
		["VOLUME_UP"] = "",
		["VOLUME_DOWN"] = "",
		["MUTE_ON"] = "",
		["MUTE_OFF"] = "",
		["MUTE_TOGGLE"] = "",		
	}
	
	CMDS_IR[RECEIVER_PROXY_BINDINGID] = {}	
	
	CMDS_IR[TUNER_PROXY_BINDINGID] = {
		--values are IRCode ID as defined in IRCode XML declarations
		["PULSE_CH_UP"]="",
		["START_CH_UP"]="",		--used for PULSE_CH_UP in some Navigators
		["SKIP_FWD"]="",		--used for PULSE_CH_UP in some Navigators	
		["PULSE_CH_DOWN"]="",
		["START_CH_DOWN"]="",	--used for PULSE_CH_DOWN in some Navigators
		["SKIP_REV"]="",		--used for PULSE_CH_DOWN in some Navigators
		["PRESET_UP"]="",	
		["PRESET_DOWN"]="",
		["INPUT_TOGGLE"]="",	  --BAND Toggle NOT MAPPED?
		['PAGE_UP']="",		--Preset Up
		['PAGE_DOWN']="",	--Peeset Down	
		
		--these entries are only required if 
		--specific command codes are required for the Tuner
		["STAR"]="TAC",
		["NUMBER_0"]="", 	
		["NUMBER_1"]="",	
		["NUMBER_2"]="",	
		["NUMBER_3"]="",	
		["NUMBER_4"]="",	
		["NUMBER_5"]="",	
		["NUMBER_6"]="",	
		["NUMBER_7"]="",	
		["NUMBER_8"]="",	
		["NUMBER_9"]="",
		
		
	}		
end
--]]

function PROTOCOL_DECLARATIONS.CommandsTableInit_Serial()
	LogTrace("PROTOCOL_DECLARATIONS.CommandsTableInit_Serial()")

	CMDS = {
		--index:  Proxy Command Name
		--value:  Protocol Command Data
		
		--Power
		["ON"]             = "",
		["OFF"]            = "",
			
		--Menu
		["INFO"] = "",	--Display
		["GUIDE"] = "",
		["MENU"] = "",
		["CANCEL"] = "",
		["UP"] = "",
		["DOWN"] = "",
		["LEFT"] = "",
		["RIGHT"] = "",
		["ENTER"] = "",	
		["RECALL"]         = "",
		["PREV"]           = "",
		
		--Digits
		["NUMBER_0"]       = "", 	
		["NUMBER_1"]       = "",		
		["NUMBER_2"]       = "",	
		["NUMBER_3"]       = "",	
		["NUMBER_4"]       = "",	
		["NUMBER_5"]       = "",	
		["NUMBER_6"]       = "",	
		["NUMBER_7"]       = "",	
		["NUMBER_8"]       = "",	
		["NUMBER_9"]       = "",
		["STAR"]           = "",
		["DOT"]            = "",
	}
	
	CMDS[RECEIVER_PROXY_BINDINGID] = {}
	
	CMDS[TUNER_PROXY_BINDINGID] = {
		["PULSE_CH_UP"]="",
		["START_CH_UP"]="",		--used for PULSE_CH_UP in some Navigators
		["SKIP_FWD"]="",		--used for PULSE_CH_UP in some Navigators	
		["SCAN_FWD"]="",		
		["PULSE_CH_DOWN"]="",	--used for PULSE_CH_UP in some Navigators
		["START_CH_DOWN"]="",	--used for PULSE_CH_DOWN in some Navigators
		["SKIP_REV"]="",		--used for PULSE_CH_DOWN in some Navigators
		["SCAN_REV"]="",
		["PRESET_UP"]="",	
		["PRESET_DOWN"]="",
		["INPUT_TOGGLE"]="",	  --BAND Toggle NOT MAPPED?
		
		--these entries are only required if 
		--specific command strings are required for the Tuner
		["STAR"]="TAC",
		["NUMBER_0"]="", 	
		["NUMBER_1"]="",	
		["NUMBER_2"]="",	
		["NUMBER_3"]="",	
		["NUMBER_4"]="",	
		["NUMBER_5"]="",	
		["NUMBER_6"]="",	
		["NUMBER_7"]="",	
		["NUMBER_8"]="",	
		["NUMBER_9"]="",
	}	
	
end

function PROTOCOL_DECLARATIONS.InputOutputTableInit()
	LogTrace("PROTOCOL_DECLARATIONS.InputOutputTableInit()")
	----------------------------------------- [*COMMAND/RESPONSE HELPER TABLES*] -----------------------------------------
	
	tOutputCommandMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Protocol Command Data
		[0] = "1",
		[1] = "1",
		[2] = "1",
		[3] = "1",
	}

	tInputCommandMap = {
		--index:  Connection Name
		--value:  Protocol Command Data	
		--["ADAPTER PORT"] = "33", 
	   ["Balanced"] = "1",
	}
	
	tInputResponseMap = ReverseTable(tInputCommandMap)	-- Reverses the tInputCommandMap table
	
	--[[
	tInputCommandMap[TUNER_PROXY_BINDINGID] = {
		["AM Antenna"] = "",
		["FM Antenna"] = "", 
	}	
	
	tInputCommandMap_IR = { 
	}
	--Main Zone Input Selection Commands	
	tInputCommandMap_IR[0] = { 
		--index:  Connection Name
		--value:  IR Code ID
		--["ADAPTER PORT"] = "51362",
		[""] = "",
	}
	--Zone2 Input Selection Commands
	tInputCommandMap_IR[1] = { 	
		[""] = "",
	}
	--Zone3 Input Selection Commands
	tInputCommandMap_IR[2] = { 
		[""] = "",
	}
	--Zone4 Input Selection Commands	
	tInputCommandMap_IR[3] = { 
		[""] = "",
	}	
	
	--Tuner Antennas
	tInputCommandMap_IR[TUNER_PROXY_BINDINGID] = {
		--values are IRCode ID as defined in IRCode XML declarations
		["AM Antenna"] = "",
		["FM Antenna"] = "", 
	}	
	
	----------------------------------------- [*I/O HELPER TABLES*] -----------------------------------------
	tOutputConnMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Output Connection Name
		[0] = "Main Output",
		[1] = "Zone2 Output",
		[2] = "Zone3 Output",
		[3] = "Zone4 Output",
	}

	tInputConnMapByID = {
		--index:  mod 1000 value of Input Connection id
		--[0] = {Name = "INPUT HDMI 1",BindingID = RECEIVER_PROXY_BINDINGID,},
		--The first two entries below are for the antenna connections which are bound to the tuner proxy; the in values will need to be updated base on the connection ID.
		[0] = {Name = "FM Antenna",BindingID = TUNER_PROXY_BINDINGID,},
		[0] = {Name = "AM Antenna",BindingID = TUNER_PROXY_BINDINGID,},
		[0] = {Name = "",BindingID = RECEIVER_PROXY_BINDINGID,},
	}
	
	tInputConnMapByName = {
		--index:  Input Connection Name
		--ID: mod 1000 value of Input Connection id
		--["INPUT HDMI 1"] = {ID = 0,BindingID = RECEIVER_PROXY_BINDINGID,},
		["FM Antenna"] = {ID = 0,BindingID = TUNER_PROXY_BINDINGID,},
		["AM Antenna"] = {ID = 0,BindingID = TUNER_PROXY_BINDINGID,},
		[""] = {ID = 0,BindingID = RECEIVER_PROXY_BINDINGID,},
	}
	--]]

end	

--[[
function PROTOCOL_DECLARATIONS.PowerCommandsTableInit_Serial()
	LogTrace("PROTOCOL_DECLARATIONS.PowerCommandsTableInit_Serial()")
	
	tPowerCommandMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Protocol Command Data (Power)
		[0] = "",
		[1] = "",
		[2] = "",
		[3] = "",
	}
end
--]]

function PROTOCOL_DECLARATIONS.VolumeCommandsTableInit_Serial()
	LogTrace("PROTOCOL_DECLARATIONS.VolumeCommandsTableInit_Serial()")
	
	tVolumeCommandMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Protocol Command Data (Pulse Volume - command prefix/suffix)
		[0] = "1",
		[1] = "1",
		[2] = "1",
		[3] = "1",	
	}

	tVolumeSetCommandMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Protocol Command Data (Discreet Volume - command prefix/suffix)	
		[0] = "1",
		[1] = "1",
		[2] = "1",
		[3] = "1", 
	}
	
	tVolumeQueryMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Protocol Command Data (Volume Query)		
		[0] = "1",
		[1] = "1",
		[2] = "1",
		[3] = "1", 	
	}	

	tMuteCommandMap = {
		--index:  mod 1000 value of Output Connection id
		--value:  Protocol Command Data (Mute - command prefix/suffix)		
		[0] = "1",
		[1] = "1",
		[2] = "1",
		[3] = "1",
	}	
	
	--[[
	TODO: Update tVolumeCurve table based upon devices volume range and optimal ramping steps
		tVolumeCurve is used to plot values that will be used
		to build volume commands during volume ramping.
		Specifically, they are used in GetNextVolumeCurveValue() which is 
		called from the ContinueVolumeRamping() function. 
		The values entered here should correlate to the volume parameters as defined in the device protocol.
		Below is an example, the table for your device may use different values.
		Also the number and size of steps may differ for your device. Adjust values to get 
		a smooth volume ramping from low to high volume.
		NOTE: values must be in decimal (i.e. not hexadecimal...)
	--]]
	tVolumeCurve = {
	   -- 4 unit STEPS [0 to 20]
	   0,4,8,12,16,20,
	   -- 2 unit STEPS [20 to 60]
	   22,24,26,28,30,32,34,36,38,40,
	   42,44,46,48,50,52,54,56,58,60,
	   -- 1 unit STEPS [60 to 100]
	   61,62,63,64,65,66,67,68,69,70,
	   71,72,73,74,75,76,77,78,79,80,
	   81,82,83,84,85,86,87,88,89,90,
	   91,92,93,94,95,96,97,98,100 -- 100% and 99% will both be converted to volume value 99                             
	}
	
end

function ReverseTable(a)
	local b = {}
	for k,v in pairs(a) do b[v] = k end
	return b
end

